java.lang

## Class Process

- java.lang.Object
- - java.lang.Process

-     public abstract class Process
      extends Object

  The `ProcessBuilder.start()` and `Runtime.exec` methods create a native process and return an instance of a subclass of `Process` that can be used to control the process and obtain information about it. The class `Process` provides methods for performing input from the process, performing output to the process, waiting for the process to complete, checking the exit status of the process, and destroying (killing) the process.

  The methods that create processes may not work well for special processes on certain native platforms, such as native windowing processes, daemon processes, Win16/DOS processes on Microsoft Windows, or shell scripts.

  By default, the created subprocess does not have its own terminal or console. All its standard I/O (i.e. stdin, stdout, stderr) operations will be redirected to the parent process, where they can be accessed via the streams obtained using the methods `getOutputStream()`, `getInputStream()`, and `getErrorStream()`. The parent process uses these streams to feed input to and get output from the subprocess. Because some native platforms only provide limited buffer size for standard input and output streams, failure to promptly write the input stream or read the output stream of the subprocess may cause the subprocess to block, or even deadlock.

  Where desired, subprocess I/O can also be redirected using methods of the `ProcessBuilder` class.

  The subprocess is not killed when there are no more references to the `Process` object, but rather the subprocess continues executing asynchronously.

  There is no requirement that a process represented by a `Process` object execute asynchronously or concurrently with respect to the Java process that owns the `Process` object.

  As of 1.5, `ProcessBuilder.start()` is the preferred way to create a `Process`.

  Since:
    JDK1.0

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `Process()`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `abstract void` | `destroy()` Kills the subprocess.
    `abstract int` | `exitValue()` Returns the exit value for the subprocess.
    `abstract InputStream` | `getErrorStream()` Returns the input stream connected to the error output of the subprocess.
    `abstract InputStream` | `getInputStream()` Returns the input stream connected to the normal output of the subprocess.
    `abstract OutputStream` | `getOutputStream()` Returns the output stream connected to the normal input of the subprocess.
    `abstract int` | `waitFor()` Causes the current thread to wait, if necessary, until the process represented by this `Process` object has terminated.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### Process

          public Process()

  - ### Method Detail

    - #### getOutputStream

          public abstract OutputStream getOutputStream()

      Returns the output stream connected to the normal input of the subprocess. Output to the stream is piped into the standard input of the process represented by this `Process` object.

      If the standard input of the subprocess has been redirected using `ProcessBuilder.redirectInput` then this method will return a null output stream.

      Implementation note: It is a good idea for the returned output stream to be buffered.

      Returns:
        the output stream connected to the normal input of the subprocess

    - #### getInputStream

          public abstract InputStream getInputStream()

      Returns the input stream connected to the normal output of the subprocess. The stream obtains data piped from the standard output of the process represented by this `Process` object.

      If the standard output of the subprocess has been redirected using `ProcessBuilder.redirectOutput` then this method will return a null input stream.

      Otherwise, if the standard error of the subprocess has been redirected using `ProcessBuilder.redirectErrorStream` then the input stream returned by this method will receive the merged standard output and the standard error of the subprocess.

      Implementation note: It is a good idea for the returned input stream to be buffered.

      Returns:
        the input stream connected to the normal output of the subprocess

    - #### getErrorStream

          public abstract InputStream getErrorStream()

      Returns the input stream connected to the error output of the subprocess. The stream obtains data piped from the error output of the process represented by this `Process` object.

      If the standard error of the subprocess has been redirected using `ProcessBuilder.redirectError` or `ProcessBuilder.redirectErrorStream` then this method will return a null input stream.

      Implementation note: It is a good idea for the returned input stream to be buffered.

      Returns:
        the input stream connected to the error output of the subprocess

    - #### waitFor

          public abstract int waitFor()
                               throws InterruptedException

      Causes the current thread to wait, if necessary, until the process represented by this `Process` object has terminated. This method returns immediately if the subprocess has already terminated. If the subprocess has not yet terminated, the calling thread will be blocked until the subprocess exits.
      Returns:
        the exit value of the subprocess represented by this `Process` object. By convention, the value `0` indicates normal termination.
      Throws:
        `InterruptedException` - if the current thread is interrupted by another thread while it is waiting, then the wait is ended and an `InterruptedException` is thrown.

    - #### exitValue

          public abstract int exitValue()

      Returns the exit value for the subprocess.
      Returns:
        the exit value of the subprocess represented by this `Process` object. By convention, the value `0` indicates normal termination.
      Throws:
        `IllegalThreadStateException` - if the subprocess represented by this `Process` object has not yet terminated

    - #### destroy

          public abstract void destroy()

      Kills the subprocess. The subprocess represented by this `Process` object is forcibly terminated.

Submit a bug or feature
For further API reference and developer documentation, see Java SE Documentation. That documentation contains more detailed, developer-targeted descriptions, with conceptual overviews, definitions of terms, workarounds, and working code examples.
Copyright © 1993, 2014, Oracle and/or its affiliates. All rights reserved.